--[[
Don't edit or remove this comment block! It is used by the editor to store information since i'm too lazy to write a good LUA parser... -Haz
SETTINGS
RestrictedEnhancements=
RestrictedCategories=
END
--]]


local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local ScenarioFramework = import('/lua/ScenarioFramework.lua')
local currentResSpot = 0

local generatedMass = {}
local checkedExtractor = {}

function OnPopulate()
  ScenarioUtils.InitializeArmies()
end

function OnStart(self)
	checkMassPoint()
end


function checkMassPoint()
	ForkThread( function()
		while(true)do
			local units = GetUnitsInRect({x0 = 0, x1 = 255, y0 = 0, y1 = 255})
			if(units~=nil)then
				for i,unit in units do --On r�cup toutes les unit�s
					if(EntityCategoryContains(categories.MASSEXTRACTION,unit))then
						posx = unit:GetPosition()[1]
						posy = unit:GetPosition()[3]
						if(not alreadyCheckedExtractor(posx, posy))then
							GenerateResourcesMarker(posx - 2, posy)
							GenerateResourcesMarker(posx + 2, posy)
							GenerateResourcesMarker(posx, posy - 2)
							GenerateResourcesMarker(posx, posy + 2)
						end
						WaitSeconds( 0.01 )
					end
				end
			end
			WaitSeconds( 1 )
		end
	end)
end

function alreadyCheckedExtractor(x,y)
	local foundIt = false
	if(checkedExtractor[x]==nil)then -- nouveau X
		checkedExtractor[x]={}
		checkedExtractor[x][y] = true
	else
		if(checkedExtractor[x][y]==nil)then -- nouveau Y
			checkedExtractor[x][y] = true	
		else
			foundIt = true
		end
	end
	return foundIt
end

function GenerateResourcesMarker(x, y)
	local foundIt = false
	if(generatedMass[x]==nil)then -- nouveau X
		generatedMass[x]={}
		generatedMass[x][y] = true
	else
		if(generatedMass[x][y]==nil)then -- nouveau Y
			generatedMass[x][y] = true	
		else
			foundIt = true
		end
	end
	
	if(not foundIt)then
		tmptable = {x, y}
		table.insert(generatedMass, tmptable)
		marker =
		{
			['Mass '..(100 + currentResSpot)] =
			{
				['type'] = STRING( 'Mass' ),
				['position'] = VECTOR3( x, 0, y ),
				['orientation'] = VECTOR3( 0.00, 0.00, 0.00 ),
				['size'] = FLOAT( 1.00 ),
				['resource'] = BOOLEAN( true ),
				['amount'] = FLOAT( 100.00 ),
				['color'] = STRING( 'ff808080' ),
				['editorIcon'] = STRING( '/textures/editor/marker_mass.bmp' ),
				['prop'] = STRING( '/env/common/props/markers/M_Mass_prop.bp' ),
			},
		}
		currentResSpot = currentResSpot + 1
		CreateResources(marker)
	end
end

function CreateResources(markers)
    --local markers = GetMarkers()

    for i, tblData in pairs(markers) do
        if tblData.resource then
            CreateResourceDeposit(
                tblData.type,
                tblData.position[1], tblData.position[2], tblData.position[3],
                tblData.size
            )

            local albedo, sx, sz, lod
            if tblData.type == "Mass" then
                albedo = "/env/common/splats/mass_marker.dds"
                sx = 2
                sz = 2
                lod = 100
                CreatePropHPR(
                    '/env/common/props/massDeposit01_prop.bp',
                    tblData.position[1], tblData.position[2], tblData.position[3],
                    Random(0,360), 0, 0
                )
            else
                albedo = "/env/common/splats/hydrocarbon_marker.dds"
                sx = 6
                sz = 6
                lod = 200
                CreatePropHPR(
                    '/env/common/props/hydrocarbonDeposit01_prop.bp',
                    tblData.position[1], tblData.position[2], tblData.position[3],
                    Random(0,360), 0, 0
                )
            end

            CreateSplat(
                tblData.position,           # Position
                0,                          # Heading (rotation)
                albedo,                     # Texture name for albedo
                sx, sz,                     # SizeX/Z
                lod,                        # LOD
                0,                          # Duration (0 == does not expire)
                -1 ,                         # army (-1 == not owned by any single army)
                0
            )
        end
    end
end